package inua.elf;

public class PT
{
  static public final int NULL = 0;
  static public final int LOAD = 1;
  static public final int DYNAMIC = 2;
  static public final int INTERP = 3;
  static public final int NOTE = 4;
  static public final int SHLIB = 5;
  static public final int PHDR = 6;
  static public final int TLS = 7;
  static public final int NUM = 8;
  static public final int GNU_EH_FRAME = 0x6474e550;
  static public final int GNU_STACK = 0x6474e551;
  static public final int GNU_RELRO = 0x6474e552;

  static public String toString (long i)
  {
    switch ((int) i) {
    case NULL: return "PT_NULL";
    case LOAD: return "PT_LOAD";
    case DYNAMIC: return "PT_DYNAMIC";
    case INTERP: return "PT_INTERP";
    case NOTE: return "PT_NOTE";
    case SHLIB: return "PT_SHLIB";
    case PHDR: return "PT_PHDR";
    case TLS: return "PT_TLS";
    case NUM: return "PT_NUM";
    case GNU_EH_FRAME: return "PT_GNU_EH_FRAME";
    case GNU_STACK: return "PT_GNU_STACK";
    case GNU_RELRO: return "PT_GNU_RELRO";
    default: return "PT_0x" + Long.toHexString (i);
    }
  }

  static public String toShortString (long i)
  {
    switch ((int) i) {
    case NULL: return "NULL";
    case LOAD: return "LOAD";
    case DYNAMIC: return "DYNAMIC";
    case INTERP: return "INTERP";
    case NOTE: return "NOTE";
    case SHLIB: return "SHLIB";
    case PHDR: return "PHDR";
    case TLS: return "TLS";
    case NUM: return "NUM";
    case GNU_EH_FRAME: return "GNU_EH_FRAME";
    case GNU_STACK: return "GNU_STACK";
    case GNU_RELRO: return "GNU_RELRO";
    default: return "PT_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i)
  {
    switch ((int) i) {
    case NULL: return "NULL";
    case LOAD: return "LOAD";
    case DYNAMIC: return "DYNAMIC";
    case INTERP: return "INTERP";
    case NOTE: return "NOTE";
    case SHLIB: return "SHLIB";
    case PHDR: return "PHDR";
    case TLS: return "TLS";
    case NUM: return "NUM";
    case GNU_EH_FRAME: return "GNU EH FRAME";
    case GNU_STACK: return "GNU STACK";
    case GNU_RELRO: return "GNU RELRO";
    default: return "PT_0x" + Long.toHexString (i);
    }
  }

  static public String toPrintString (long i, String def)
  {
    switch ((int) i) {
    case NULL: return "NULL";
    case LOAD: return "LOAD";
    case DYNAMIC: return "DYNAMIC";
    case INTERP: return "INTERP";
    case NOTE: return "NOTE";
    case SHLIB: return "SHLIB";
    case PHDR: return "PHDR";
    case TLS: return "TLS";
    case NUM: return "NUM";
    case GNU_EH_FRAME: return "GNU EH FRAME";
    case GNU_STACK: return "GNU STACK";
    case GNU_RELRO: return "GNU RELRO";
    default: return def;
    }
  }
}
